import io.netty.bootstrap.Bootstrap;
import io.netty.channel.Channel;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.nio.NioSocketChannel;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class FactorClient {

    public static void main(String[] args) throws Exception {
        if (args.length !=2) {
            System.out.println("usage: factor-client host port");
            return;
        }
        new FactorClient(args[0], Integer.parseInt(args[1])).run();
    }

    private final String host;
    private final int port;

    public FactorClient(String host, int port) {
        this.host = host;
        this.port = port;
    }

    public void run() throws Exception {
        EventLoopGroup group = new NioEventLoopGroup();

        try {
            Bootstrap bootstrap = new Bootstrap()
                    .group(group)
                    .channel(NioSocketChannel.class)
                    .handler(new FactorClientInitializer());
            Channel channel = bootstrap.connect(host, port).sync().channel();
            BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

            while (true) {

            }
        } finally {
            group.shutdownGracefully();
        }
    }
}
