import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundMessageHandlerAdapter;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class FactorClientHandler extends ChannelInboundMessageHandlerAdapter<String>{

    @Override
    public void messageReceived(ChannelHandlerContext channelHandlerContext, String task) throws Exception {
        System.out.println("Hey");
        if (task.startsWith("FACTOR")) {
            BigInteger numbers = new BigInteger(task.replace("FACTOR ", ""));
            System.out.println(numbers);
            List<BigInteger> factors = factors(numbers);
            channelHandlerContext.channel().write("FACTOR");
            for (BigInteger factor : factors) {
                channelHandlerContext.channel().write(factor + " ");
            }
            channelHandlerContext.channel().write("\n");

        }

    }
    private List<BigInteger> factors(BigInteger numbers) {
        BigInteger n = numbers;
        List<BigInteger> factors = new ArrayList<BigInteger>();
        BigInteger i = new BigInteger("2");
        while (i.compareTo(n) <0) {
            while(n.mod(i).equals(BigInteger.ZERO)) {
                System.out.println(i);
                factors.add(i);
                n = n.divide(i);
            }
            i = i.add(BigInteger.ONE);
        }
        if (n.compareTo(BigInteger.ZERO)>0) {
            factors.add(n);
        }
        return factors;
    }

    private BigInteger sqrt(BigInteger n) {
        BigInteger a = BigInteger.ONE;
        BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
        while(b.compareTo(a) >= 0) {
            BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
            if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
            else a = mid.add(BigInteger.ONE);
        }
        return a.subtract(BigInteger.ONE);
    }


}
