import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.nio.NioServerSocketChannel;

import java.math.BigInteger;


public class FactorServer {

    private static final  int SERVER_PORT = 1234;

    public static  BigInteger number;

    public static void main(String[] args) throws Exception {
        if (args.length!=1) {
            System.out.println("usage: factor-server n" +
                    "          n: number for factorization");
            return;
        }

        new FactorServer(SERVER_PORT,new BigInteger(args[0])).run();
    }

    public FactorServer(int port, BigInteger number) {
        this.port = port;
        FactorServer.number = number;
    }

    private final int port;

    public void run() throws Exception{
        EventLoopGroup bossGroup = new NioEventLoopGroup();
        EventLoopGroup workerGroup = new NioEventLoopGroup();

        try{
            ServerBootstrap bootstrap = new ServerBootstrap()
                    .group(bossGroup, workerGroup)
                    .channel(NioServerSocketChannel.class)
                    .childHandler(new FactorServerInitializer());
            bootstrap.bind(port).sync().channel().closeFuture().sync();
        }
        finally {
            bossGroup.shutdownGracefully();
            workerGroup.shutdownGracefully();
        }
    }
}
