package ru.volgait2015.strepetov.unixgoogle;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;

/**
 * Represents console google search
 */
public class UnixGoogle {
    //base google url
    private static final String GOOGLE = "http://www.google.com/search?q=";
    //encoding charset
    private static final String CHARSET = "UTF-8";
    //just fake user-agent
    private static final String USER_AGENT = "VolgaIT 1.0 ()";
    //if WITH_ADS = true, unix-google will return results with news,ads and e.t.c
    private static final boolean WITH_ADS = false;

    /** Prints to console first 10 google search'result on a word arg[0]
     * @param args args[0]: word for google search
     */
    public static void main(String[] args) {

        if (args.length != 1) {
            System.out.println("usage: unix-google word");
            return;
        }

        String word = args[0];
        Elements links = null;
        try {
            links = Jsoup.connect(GOOGLE + URLEncoder.encode(word, CHARSET)).userAgent(USER_AGENT).get().select("li.g>h3>a");
        } catch (IOException e) {
            e.printStackTrace();
        }

        assert links != null;

        for (Element link : links) {
            String title = link.text();
            String url = link.absUrl("href");
            try {
                url = URLDecoder.decode(url.substring(url.indexOf('=') + 1, url.indexOf('&')), "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }

            if (!url.startsWith("http") && !WITH_ADS) {
                continue;
            }

            System.out.print("\"" + title + "\"");
            System.out.println("[" + url + "]");
        }
    }
}
